> For the complete documentation index, see [llms.txt](https://docs.tensorleap.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tensorleap.ai/tensorleap-integration/python-api/code_loader/visualizer_classes/leapimage.md).

# LeapImage

code\_loader.contract.visualizer\_classes.LeapImage

Used to visualize a grayscale/RGB image

```python
import numpy.typing as npt
from code_loader.contract.enums import LeapDataType

@dataclass
class LeapImage:
    data: Union[npt.NDArray[np.float32], npt.NDArray[np.uint8]]
    type: LeapDataType = LeapDataType.Image
    compress: Optional[bool] = True
```

<table><thead><tr><th width="167.39065467110788">Args</th><th></th></tr></thead><tbody><tr><td><code>data</code></td><td>np.ndarray uint8/float32 representation of the image. The expected image format is [H,W,1] OR [H,W,3]. For uint8, values should be in [0,255]. For float32, values should be in [0,1].</td></tr><tr><td><code>compress</code></td><td>(boolean, optional). Images are automatically compressed to jpg in the platform. For visualization that require no compression, set compress=False to get a png.</td></tr></tbody></table>

## Examples

#### Basic Usage

```python
from code_loader.contract.visualizer_classes import LeapImage
import cv2
...

@tensorleap_custom_visualizer(name='bgr2rgb_vis',
                              visualizer_type=LeapDataType.Image)
def bgr2rgb_visualizer(data: np.ndarray) -> LeapImage:
    im_rgb = cv2.cvtColor(data, cv2.COLOR_BGR2RGB)
    return LeapImage(im_rgb)
```

#### Resize Image and Heat-map

```python
from code_loader.contract.visualizer_classes import LeapImage
import numpy.typing as npt
from code_loader.contract.enums import LeapDataType

def resized_image_visualizer_heatmap(data: npt.NDArray[np.float32]) -> npt.NDArray[np.float32]:
    # data is the heatmap with original size (origin_W, origin_H)
    return np.resize(data, (256, 512))    # we reshape to the resized shape
    
@tensorleap_custom_visualizer(name='image_visualizer',
                              visualizer_type=LeapDataType.Image,
                              heatmap_function=resized_image_visualizer_heatmap)
def resized_image_visualizer(data: npt.NDArray[np.float32]) -> LeapImage:
    return LeapImage(np.resize(data, (256, 512, 3)))
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.tensorleap.ai/tensorleap-integration/python-api/code_loader/visualizer_classes/leapimage.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
